# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
"""
This file contains the exact signatures for all functions in module
PySide6.QtCharts, except for defaults which are replaced by "...".
"""

# mypy: disable-error-code="override, overload-overlap"
# Module `PySide6.QtCharts`

import PySide6.QtCharts
import PySide6.QtCore
import PySide6.QtWidgets

import enum
import typing
from PySide6.QtCore import Signal


class QAbstractAxis(PySide6.QtCore.QObject):

    colorChanged             : typing.ClassVar[Signal] = ... # colorChanged(QColor)
    gridLineColorChanged     : typing.ClassVar[Signal] = ... # gridLineColorChanged(QColor)
    gridLinePenChanged       : typing.ClassVar[Signal] = ... # gridLinePenChanged(QPen)
    gridVisibleChanged       : typing.ClassVar[Signal] = ... # gridVisibleChanged(bool)
    labelsAngleChanged       : typing.ClassVar[Signal] = ... # labelsAngleChanged(int)
    labelsBrushChanged       : typing.ClassVar[Signal] = ... # labelsBrushChanged(QBrush)
    labelsColorChanged       : typing.ClassVar[Signal] = ... # labelsColorChanged(QColor)
    labelsEditableChanged    : typing.ClassVar[Signal] = ... # labelsEditableChanged(bool)
    labelsFontChanged        : typing.ClassVar[Signal] = ... # labelsFontChanged(QFont)
    labelsTruncatedChanged   : typing.ClassVar[Signal] = ... # labelsTruncatedChanged(bool)
    labelsVisibleChanged     : typing.ClassVar[Signal] = ... # labelsVisibleChanged(bool)
    linePenChanged           : typing.ClassVar[Signal] = ... # linePenChanged(QPen)
    lineVisibleChanged       : typing.ClassVar[Signal] = ... # lineVisibleChanged(bool)
    minorGridLineColorChanged: typing.ClassVar[Signal] = ... # minorGridLineColorChanged(QColor)
    minorGridLinePenChanged  : typing.ClassVar[Signal] = ... # minorGridLinePenChanged(QPen)
    minorGridVisibleChanged  : typing.ClassVar[Signal] = ... # minorGridVisibleChanged(bool)
    reverseChanged           : typing.ClassVar[Signal] = ... # reverseChanged(bool)
    shadesBorderColorChanged : typing.ClassVar[Signal] = ... # shadesBorderColorChanged(QColor)
    shadesBrushChanged       : typing.ClassVar[Signal] = ... # shadesBrushChanged(QBrush)
    shadesColorChanged       : typing.ClassVar[Signal] = ... # shadesColorChanged(QColor)
    shadesPenChanged         : typing.ClassVar[Signal] = ... # shadesPenChanged(QPen)
    shadesVisibleChanged     : typing.ClassVar[Signal] = ... # shadesVisibleChanged(bool)
    titleBrushChanged        : typing.ClassVar[Signal] = ... # titleBrushChanged(QBrush)
    titleFontChanged         : typing.ClassVar[Signal] = ... # titleFontChanged(QFont)
    titleTextChanged         : typing.ClassVar[Signal] = ... # titleTextChanged(QString)
    titleVisibleChanged      : typing.ClassVar[Signal] = ... # titleVisibleChanged(bool)
    truncateLabelsChanged    : typing.ClassVar[Signal] = ... # truncateLabelsChanged(bool)
    visibleChanged           : typing.ClassVar[Signal] = ... # visibleChanged(bool)

    class AxisType(enum.Enum):

        AxisTypeNoAxis            = 0x0
        AxisTypeValue             = 0x1
        AxisTypeBarCategory       = 0x2
        AxisTypeCategory          = 0x4
        AxisTypeDateTime          = 0x8
        AxisTypeLogValue          = 0x10
        AxisTypeColor             = 0x20


class QAbstractBarSeries(PySide6.QtCharts.QAbstractSeries):

    barsetsAdded             : typing.ClassVar[Signal] = ... # barsetsAdded(QList<QBarSet*>)
    barsetsRemoved           : typing.ClassVar[Signal] = ... # barsetsRemoved(QList<QBarSet*>)
    clicked                  : typing.ClassVar[Signal] = ... # clicked(int,QBarSet*)
    countChanged             : typing.ClassVar[Signal] = ... # countChanged()
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked(int,QBarSet*)
    hovered                  : typing.ClassVar[Signal] = ... # hovered(bool,int,QBarSet*)
    labelsAngleChanged       : typing.ClassVar[Signal] = ... # labelsAngleChanged(double)
    labelsFormatChanged      : typing.ClassVar[Signal] = ... # labelsFormatChanged(QString)
    labelsPositionChanged    : typing.ClassVar[Signal] = ... # labelsPositionChanged(QAbstractBarSeries::LabelsPosition)
    labelsPrecisionChanged   : typing.ClassVar[Signal] = ... # labelsPrecisionChanged(int)
    labelsVisibleChanged     : typing.ClassVar[Signal] = ... # labelsVisibleChanged()
    pressed                  : typing.ClassVar[Signal] = ... # pressed(int,QBarSet*)
    released                 : typing.ClassVar[Signal] = ... # released(int,QBarSet*)

    class LabelsPosition(enum.Enum):

        LabelsCenter              = 0x0
        LabelsInsideEnd           = 0x1
        LabelsInsideBase          = 0x2
        LabelsOutsideEnd          = 0x3


class QAbstractSeries(PySide6.QtCore.QObject):

    nameChanged              : typing.ClassVar[Signal] = ... # nameChanged()
    opacityChanged           : typing.ClassVar[Signal] = ... # opacityChanged()
    useOpenGLChanged         : typing.ClassVar[Signal] = ... # useOpenGLChanged()
    visibleChanged           : typing.ClassVar[Signal] = ... # visibleChanged()

    class SeriesType(enum.Enum):

        SeriesTypeLine            = 0x0
        SeriesTypeArea            = 0x1
        SeriesTypeBar             = 0x2
        SeriesTypeStackedBar      = 0x3
        SeriesTypePercentBar      = 0x4
        SeriesTypePie             = 0x5
        SeriesTypeScatter         = 0x6
        SeriesTypeSpline          = 0x7
        SeriesTypeHorizontalBar   = 0x8
        SeriesTypeHorizontalStackedBar = 0x9
        SeriesTypeHorizontalPercentBar = 0xa
        SeriesTypeBoxPlot         = 0xb
        SeriesTypeCandlestick     = 0xc


class QAreaLegendMarker(PySide6.QtCharts.QLegendMarker): ...


class QAreaSeries(PySide6.QtCharts.QAbstractSeries):

    borderColorChanged       : typing.ClassVar[Signal] = ... # borderColorChanged(QColor)
    clicked                  : typing.ClassVar[Signal] = ... # clicked(QPointF)
    colorChanged             : typing.ClassVar[Signal] = ... # colorChanged(QColor)
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked(QPointF)
    hovered                  : typing.ClassVar[Signal] = ... # hovered(QPointF,bool)
    pointLabelsClippingChanged: typing.ClassVar[Signal] = ... # pointLabelsClippingChanged(bool)
    pointLabelsColorChanged  : typing.ClassVar[Signal] = ... # pointLabelsColorChanged(QColor)
    pointLabelsFontChanged   : typing.ClassVar[Signal] = ... # pointLabelsFontChanged(QFont)
    pointLabelsFormatChanged : typing.ClassVar[Signal] = ... # pointLabelsFormatChanged(QString)
    pointLabelsVisibilityChanged: typing.ClassVar[Signal] = ... # pointLabelsVisibilityChanged(bool)
    pressed                  : typing.ClassVar[Signal] = ... # pressed(QPointF)
    released                 : typing.ClassVar[Signal] = ... # released(QPointF)
    selected                 : typing.ClassVar[Signal] = ... # selected()


class QBarCategoryAxis(PySide6.QtCharts.QAbstractAxis):

    categoriesChanged        : typing.ClassVar[Signal] = ... # categoriesChanged()
    countChanged             : typing.ClassVar[Signal] = ... # countChanged()
    maxChanged               : typing.ClassVar[Signal] = ... # maxChanged(QString)
    minChanged               : typing.ClassVar[Signal] = ... # minChanged(QString)
    rangeChanged             : typing.ClassVar[Signal] = ... # rangeChanged(QString,QString)


class QBarLegendMarker(PySide6.QtCharts.QLegendMarker): ...


class QBarModelMapper(PySide6.QtCore.QObject): ...


class QBarSeries(PySide6.QtCharts.QAbstractBarSeries): ...


class QBarSet(PySide6.QtCore.QObject):

    borderColorChanged       : typing.ClassVar[Signal] = ... # borderColorChanged(QColor)
    brushChanged             : typing.ClassVar[Signal] = ... # brushChanged()
    clicked                  : typing.ClassVar[Signal] = ... # clicked(int)
    colorChanged             : typing.ClassVar[Signal] = ... # colorChanged(QColor)
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked(int)
    hovered                  : typing.ClassVar[Signal] = ... # hovered(bool,int)
    labelBrushChanged        : typing.ClassVar[Signal] = ... # labelBrushChanged()
    labelChanged             : typing.ClassVar[Signal] = ... # labelChanged()
    labelColorChanged        : typing.ClassVar[Signal] = ... # labelColorChanged(QColor)
    labelFontChanged         : typing.ClassVar[Signal] = ... # labelFontChanged()
    penChanged               : typing.ClassVar[Signal] = ... # penChanged()
    pressed                  : typing.ClassVar[Signal] = ... # pressed(int)
    released                 : typing.ClassVar[Signal] = ... # released(int)
    selectedBarsChanged      : typing.ClassVar[Signal] = ... # selectedBarsChanged(QList<int>)
    selectedColorChanged     : typing.ClassVar[Signal] = ... # selectedColorChanged(QColor)
    valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(int)
    valuesAdded              : typing.ClassVar[Signal] = ... # valuesAdded(int,int)
    valuesRemoved            : typing.ClassVar[Signal] = ... # valuesRemoved(int,int)


class QBoxPlotLegendMarker(PySide6.QtCharts.QLegendMarker): ...


class QBoxPlotModelMapper(PySide6.QtCore.QObject): ...


class QBoxPlotSeries(PySide6.QtCharts.QAbstractSeries):

    boxOutlineVisibilityChanged: typing.ClassVar[Signal] = ... # boxOutlineVisibilityChanged()
    boxWidthChanged          : typing.ClassVar[Signal] = ... # boxWidthChanged()
    boxsetsAdded             : typing.ClassVar[Signal] = ... # boxsetsAdded(QList<QBoxSet*>)
    boxsetsRemoved           : typing.ClassVar[Signal] = ... # boxsetsRemoved(QList<QBoxSet*>)
    brushChanged             : typing.ClassVar[Signal] = ... # brushChanged()
    clicked                  : typing.ClassVar[Signal] = ... # clicked(QBoxSet*)
    countChanged             : typing.ClassVar[Signal] = ... # countChanged()
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked(QBoxSet*)
    hovered                  : typing.ClassVar[Signal] = ... # hovered(bool,QBoxSet*)
    penChanged               : typing.ClassVar[Signal] = ... # penChanged()
    pressed                  : typing.ClassVar[Signal] = ... # pressed(QBoxSet*)
    released                 : typing.ClassVar[Signal] = ... # released(QBoxSet*)


class QBoxSet(PySide6.QtCore.QObject):

    brushChanged             : typing.ClassVar[Signal] = ... # brushChanged()
    cleared                  : typing.ClassVar[Signal] = ... # cleared()
    clicked                  : typing.ClassVar[Signal] = ... # clicked()
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked()
    hovered                  : typing.ClassVar[Signal] = ... # hovered(bool)
    penChanged               : typing.ClassVar[Signal] = ... # penChanged()
    pressed                  : typing.ClassVar[Signal] = ... # pressed()
    released                 : typing.ClassVar[Signal] = ... # released()
    valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(int)
    valuesChanged            : typing.ClassVar[Signal] = ... # valuesChanged()

    class ValuePositions(enum.IntEnum):

        LowerExtreme              = 0x0
        LowerQuartile             = 0x1
        Median                    = 0x2
        UpperQuartile             = 0x3
        UpperExtreme              = 0x4


class QCandlestickLegendMarker(PySide6.QtCharts.QLegendMarker): ...


class QCandlestickModelMapper(PySide6.QtCore.QObject):

    modelReplaced            : typing.ClassVar[Signal] = ... # modelReplaced()
    seriesReplaced           : typing.ClassVar[Signal] = ... # seriesReplaced()


class QCandlestickSeries(PySide6.QtCharts.QAbstractSeries):

    bodyOutlineVisibilityChanged: typing.ClassVar[Signal] = ... # bodyOutlineVisibilityChanged()
    bodyWidthChanged         : typing.ClassVar[Signal] = ... # bodyWidthChanged()
    brushChanged             : typing.ClassVar[Signal] = ... # brushChanged()
    candlestickSetsAdded     : typing.ClassVar[Signal] = ... # candlestickSetsAdded(QList<QCandlestickSet*>)
    candlestickSetsRemoved   : typing.ClassVar[Signal] = ... # candlestickSetsRemoved(QList<QCandlestickSet*>)
    capsVisibilityChanged    : typing.ClassVar[Signal] = ... # capsVisibilityChanged()
    capsWidthChanged         : typing.ClassVar[Signal] = ... # capsWidthChanged()
    clicked                  : typing.ClassVar[Signal] = ... # clicked(QCandlestickSet*)
    countChanged             : typing.ClassVar[Signal] = ... # countChanged()
    decreasingColorChanged   : typing.ClassVar[Signal] = ... # decreasingColorChanged()
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked(QCandlestickSet*)
    hovered                  : typing.ClassVar[Signal] = ... # hovered(bool,QCandlestickSet*)
    increasingColorChanged   : typing.ClassVar[Signal] = ... # increasingColorChanged()
    maximumColumnWidthChanged: typing.ClassVar[Signal] = ... # maximumColumnWidthChanged()
    minimumColumnWidthChanged: typing.ClassVar[Signal] = ... # minimumColumnWidthChanged()
    penChanged               : typing.ClassVar[Signal] = ... # penChanged()
    pressed                  : typing.ClassVar[Signal] = ... # pressed(QCandlestickSet*)
    released                 : typing.ClassVar[Signal] = ... # released(QCandlestickSet*)


class QCandlestickSet(PySide6.QtCore.QObject):

    brushChanged             : typing.ClassVar[Signal] = ... # brushChanged()
    clicked                  : typing.ClassVar[Signal] = ... # clicked()
    closeChanged             : typing.ClassVar[Signal] = ... # closeChanged()
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked()
    highChanged              : typing.ClassVar[Signal] = ... # highChanged()
    hovered                  : typing.ClassVar[Signal] = ... # hovered(bool)
    lowChanged               : typing.ClassVar[Signal] = ... # lowChanged()
    openChanged              : typing.ClassVar[Signal] = ... # openChanged()
    penChanged               : typing.ClassVar[Signal] = ... # penChanged()
    pressed                  : typing.ClassVar[Signal] = ... # pressed()
    released                 : typing.ClassVar[Signal] = ... # released()
    timestampChanged         : typing.ClassVar[Signal] = ... # timestampChanged()


class QCategoryAxis(PySide6.QtCharts.QValueAxis):

    categoriesChanged        : typing.ClassVar[Signal] = ... # categoriesChanged()
    labelsPositionChanged    : typing.ClassVar[Signal] = ... # labelsPositionChanged(QCategoryAxis::AxisLabelsPosition)

    class AxisLabelsPosition(enum.Enum):

        AxisLabelsPositionCenter  = 0x0
        AxisLabelsPositionOnValue = 0x1


class QChart(PySide6.QtWidgets.QGraphicsWidget):

    plotAreaChanged          : typing.ClassVar[Signal] = ... # plotAreaChanged(QRectF)

    class AnimationOption(enum.Flag):

        NoAnimation               = 0x0
        GridAxisAnimations        = 0x1
        SeriesAnimations          = 0x2
        AllAnimations             = 0x3

    class ChartTheme(enum.Enum):

        ChartThemeLight           = 0x0
        ChartThemeBlueCerulean    = 0x1
        ChartThemeDark            = 0x2
        ChartThemeBrownSand       = 0x3
        ChartThemeBlueNcs         = 0x4
        ChartThemeHighContrast    = 0x5
        ChartThemeBlueIcy         = 0x6
        ChartThemeQt              = 0x7

    class ChartType(enum.Enum):

        ChartTypeUndefined        = 0x0
        ChartTypeCartesian        = 0x1
        ChartTypePolar            = 0x2


class QChartView(PySide6.QtWidgets.QGraphicsView):

    class RubberBand(enum.Flag):

        NoRubberBand              = 0x0
        VerticalRubberBand        = 0x1
        HorizontalRubberBand      = 0x2
        RectangleRubberBand       = 0x3
        ClickThroughRubberBand    = 0x80


class QColorAxis(PySide6.QtCharts.QAbstractAxis):

    autoRangeChanged         : typing.ClassVar[Signal] = ... # autoRangeChanged(bool)
    gradientChanged          : typing.ClassVar[Signal] = ... # gradientChanged(QLinearGradient)
    maxChanged               : typing.ClassVar[Signal] = ... # maxChanged(double)
    minChanged               : typing.ClassVar[Signal] = ... # minChanged(double)
    rangeChanged             : typing.ClassVar[Signal] = ... # rangeChanged(double,double)
    sizeChanged              : typing.ClassVar[Signal] = ... # sizeChanged(double)
    tickCountChanged         : typing.ClassVar[Signal] = ... # tickCountChanged(int)


class QDateTimeAxis(PySide6.QtCharts.QAbstractAxis):

    formatChanged            : typing.ClassVar[Signal] = ... # formatChanged(QString)
    maxChanged               : typing.ClassVar[Signal] = ... # maxChanged(QDateTime)
    minChanged               : typing.ClassVar[Signal] = ... # minChanged(QDateTime)
    rangeChanged             : typing.ClassVar[Signal] = ... # rangeChanged(QDateTime,QDateTime)
    tickCountChanged         : typing.ClassVar[Signal] = ... # tickCountChanged(int)


class QHBarModelMapper(PySide6.QtCharts.QBarModelMapper):

    columnCountChanged       : typing.ClassVar[Signal] = ... # columnCountChanged()
    firstBarSetRowChanged    : typing.ClassVar[Signal] = ... # firstBarSetRowChanged()
    firstColumnChanged       : typing.ClassVar[Signal] = ... # firstColumnChanged()
    lastBarSetRowChanged     : typing.ClassVar[Signal] = ... # lastBarSetRowChanged()
    modelReplaced            : typing.ClassVar[Signal] = ... # modelReplaced()
    seriesReplaced           : typing.ClassVar[Signal] = ... # seriesReplaced()


class QHBoxPlotModelMapper(PySide6.QtCharts.QBoxPlotModelMapper):

    columnCountChanged       : typing.ClassVar[Signal] = ... # columnCountChanged()
    firstBoxSetRowChanged    : typing.ClassVar[Signal] = ... # firstBoxSetRowChanged()
    firstColumnChanged       : typing.ClassVar[Signal] = ... # firstColumnChanged()
    lastBoxSetRowChanged     : typing.ClassVar[Signal] = ... # lastBoxSetRowChanged()
    modelReplaced            : typing.ClassVar[Signal] = ... # modelReplaced()
    seriesReplaced           : typing.ClassVar[Signal] = ... # seriesReplaced()


class QHCandlestickModelMapper(PySide6.QtCharts.QCandlestickModelMapper):

    closeColumnChanged       : typing.ClassVar[Signal] = ... # closeColumnChanged()
    firstSetRowChanged       : typing.ClassVar[Signal] = ... # firstSetRowChanged()
    highColumnChanged        : typing.ClassVar[Signal] = ... # highColumnChanged()
    lastSetRowChanged        : typing.ClassVar[Signal] = ... # lastSetRowChanged()
    lowColumnChanged         : typing.ClassVar[Signal] = ... # lowColumnChanged()
    openColumnChanged        : typing.ClassVar[Signal] = ... # openColumnChanged()
    timestampColumnChanged   : typing.ClassVar[Signal] = ... # timestampColumnChanged()


class QHPieModelMapper(PySide6.QtCharts.QPieModelMapper):

    columnCountChanged       : typing.ClassVar[Signal] = ... # columnCountChanged()
    firstColumnChanged       : typing.ClassVar[Signal] = ... # firstColumnChanged()
    labelsRowChanged         : typing.ClassVar[Signal] = ... # labelsRowChanged()
    modelReplaced            : typing.ClassVar[Signal] = ... # modelReplaced()
    seriesReplaced           : typing.ClassVar[Signal] = ... # seriesReplaced()
    valuesRowChanged         : typing.ClassVar[Signal] = ... # valuesRowChanged()


class QHXYModelMapper(PySide6.QtCharts.QXYModelMapper):

    columnCountChanged       : typing.ClassVar[Signal] = ... # columnCountChanged()
    firstColumnChanged       : typing.ClassVar[Signal] = ... # firstColumnChanged()
    modelReplaced            : typing.ClassVar[Signal] = ... # modelReplaced()
    seriesReplaced           : typing.ClassVar[Signal] = ... # seriesReplaced()
    xRowChanged              : typing.ClassVar[Signal] = ... # xRowChanged()
    yRowChanged              : typing.ClassVar[Signal] = ... # yRowChanged()


class QHorizontalBarSeries(PySide6.QtCharts.QAbstractBarSeries): ...


class QHorizontalPercentBarSeries(PySide6.QtCharts.QAbstractBarSeries): ...


class QHorizontalStackedBarSeries(PySide6.QtCharts.QAbstractBarSeries): ...


class QIntList: ...


class QLegend(PySide6.QtWidgets.QGraphicsWidget):

    attachedToChartChanged   : typing.ClassVar[Signal] = ... # attachedToChartChanged(bool)
    backgroundVisibleChanged : typing.ClassVar[Signal] = ... # backgroundVisibleChanged(bool)
    borderColorChanged       : typing.ClassVar[Signal] = ... # borderColorChanged(QColor)
    colorChanged             : typing.ClassVar[Signal] = ... # colorChanged(QColor)
    fontChanged              : typing.ClassVar[Signal] = ... # fontChanged(QFont)
    interactiveChanged       : typing.ClassVar[Signal] = ... # interactiveChanged(bool)
    labelColorChanged        : typing.ClassVar[Signal] = ... # labelColorChanged(QColor)
    markerShapeChanged       : typing.ClassVar[Signal] = ... # markerShapeChanged(MarkerShape)
    reverseMarkersChanged    : typing.ClassVar[Signal] = ... # reverseMarkersChanged(bool)
    showToolTipsChanged      : typing.ClassVar[Signal] = ... # showToolTipsChanged(bool)

    class MarkerShape(enum.Enum):

        MarkerShapeDefault        = 0x0
        MarkerShapeRectangle      = 0x1
        MarkerShapeCircle         = 0x2
        MarkerShapeFromSeries     = 0x3
        MarkerShapeRotatedRectangle = 0x4
        MarkerShapeTriangle       = 0x5
        MarkerShapeStar           = 0x6
        MarkerShapePentagon       = 0x7


class QLegendMarker(PySide6.QtCore.QObject):

    brushChanged             : typing.ClassVar[Signal] = ... # brushChanged()
    clicked                  : typing.ClassVar[Signal] = ... # clicked()
    fontChanged              : typing.ClassVar[Signal] = ... # fontChanged()
    hovered                  : typing.ClassVar[Signal] = ... # hovered(bool)
    labelBrushChanged        : typing.ClassVar[Signal] = ... # labelBrushChanged()
    labelChanged             : typing.ClassVar[Signal] = ... # labelChanged()
    penChanged               : typing.ClassVar[Signal] = ... # penChanged()
    shapeChanged             : typing.ClassVar[Signal] = ... # shapeChanged()
    visibleChanged           : typing.ClassVar[Signal] = ... # visibleChanged()

    class LegendMarkerType(enum.Enum):

        LegendMarkerTypeArea      = 0x0
        LegendMarkerTypeBar       = 0x1
        LegendMarkerTypePie       = 0x2
        LegendMarkerTypeXY        = 0x3
        LegendMarkerTypeBoxPlot   = 0x4
        LegendMarkerTypeCandlestick = 0x5


class QLineSeries(PySide6.QtCharts.QXYSeries): ...


class QLogValueAxis(PySide6.QtCharts.QAbstractAxis):

    baseChanged              : typing.ClassVar[Signal] = ... # baseChanged(double)
    labelFormatChanged       : typing.ClassVar[Signal] = ... # labelFormatChanged(QString)
    maxChanged               : typing.ClassVar[Signal] = ... # maxChanged(double)
    minChanged               : typing.ClassVar[Signal] = ... # minChanged(double)
    minorTickCountChanged    : typing.ClassVar[Signal] = ... # minorTickCountChanged(int)
    rangeChanged             : typing.ClassVar[Signal] = ... # rangeChanged(double,double)
    tickCountChanged         : typing.ClassVar[Signal] = ... # tickCountChanged(int)


class QPercentBarSeries(PySide6.QtCharts.QAbstractBarSeries): ...


class QPieLegendMarker(PySide6.QtCharts.QLegendMarker): ...


class QPieModelMapper(PySide6.QtCore.QObject): ...


class QPieSeries(PySide6.QtCharts.QAbstractSeries):

    added                    : typing.ClassVar[Signal] = ... # added(QList<QPieSlice*>)
    clicked                  : typing.ClassVar[Signal] = ... # clicked(QPieSlice*)
    countChanged             : typing.ClassVar[Signal] = ... # countChanged()
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked(QPieSlice*)
    hovered                  : typing.ClassVar[Signal] = ... # hovered(QPieSlice*,bool)
    pressed                  : typing.ClassVar[Signal] = ... # pressed(QPieSlice*)
    released                 : typing.ClassVar[Signal] = ... # released(QPieSlice*)
    removed                  : typing.ClassVar[Signal] = ... # removed(QList<QPieSlice*>)
    sumChanged               : typing.ClassVar[Signal] = ... # sumChanged()


class QPieSlice(PySide6.QtCore.QObject):

    angleSpanChanged         : typing.ClassVar[Signal] = ... # angleSpanChanged()
    borderColorChanged       : typing.ClassVar[Signal] = ... # borderColorChanged()
    borderWidthChanged       : typing.ClassVar[Signal] = ... # borderWidthChanged()
    brushChanged             : typing.ClassVar[Signal] = ... # brushChanged()
    clicked                  : typing.ClassVar[Signal] = ... # clicked()
    colorChanged             : typing.ClassVar[Signal] = ... # colorChanged()
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked()
    hovered                  : typing.ClassVar[Signal] = ... # hovered(bool)
    labelBrushChanged        : typing.ClassVar[Signal] = ... # labelBrushChanged()
    labelChanged             : typing.ClassVar[Signal] = ... # labelChanged()
    labelColorChanged        : typing.ClassVar[Signal] = ... # labelColorChanged()
    labelFontChanged         : typing.ClassVar[Signal] = ... # labelFontChanged()
    labelVisibleChanged      : typing.ClassVar[Signal] = ... # labelVisibleChanged()
    penChanged               : typing.ClassVar[Signal] = ... # penChanged()
    percentageChanged        : typing.ClassVar[Signal] = ... # percentageChanged()
    pressed                  : typing.ClassVar[Signal] = ... # pressed()
    released                 : typing.ClassVar[Signal] = ... # released()
    startAngleChanged        : typing.ClassVar[Signal] = ... # startAngleChanged()
    valueChanged             : typing.ClassVar[Signal] = ... # valueChanged()

    class LabelPosition(enum.Enum):

        LabelOutside              = 0x0
        LabelInsideHorizontal     = 0x1
        LabelInsideTangential     = 0x2
        LabelInsideNormal         = 0x3


class QPointFList: ...


class QPolarChart(PySide6.QtCharts.QChart):

    class PolarOrientation(enum.Flag):

        PolarOrientationRadial    = 0x1
        PolarOrientationAngular   = 0x2


class QScatterSeries(PySide6.QtCharts.QXYSeries):

    borderColorChanged       : typing.ClassVar[Signal] = ... # borderColorChanged(QColor)
    colorChanged             : typing.ClassVar[Signal] = ... # colorChanged(QColor)
    markerShapeChanged       : typing.ClassVar[Signal] = ... # markerShapeChanged(MarkerShape)
    markerSizeChanged        : typing.ClassVar[Signal] = ... # markerSizeChanged(double)

    class MarkerShape(enum.Enum):

        MarkerShapeCircle         = 0x0
        MarkerShapeRectangle      = 0x1
        MarkerShapeRotatedRectangle = 0x2
        MarkerShapeTriangle       = 0x3
        MarkerShapeStar           = 0x4
        MarkerShapePentagon       = 0x5


class QSplineSeries(PySide6.QtCharts.QLineSeries): ...


class QStackedBarSeries(PySide6.QtCharts.QAbstractBarSeries): ...


class QVBarModelMapper(PySide6.QtCharts.QBarModelMapper):

    firstBarSetColumnChanged : typing.ClassVar[Signal] = ... # firstBarSetColumnChanged()
    firstRowChanged          : typing.ClassVar[Signal] = ... # firstRowChanged()
    lastBarSetColumnChanged  : typing.ClassVar[Signal] = ... # lastBarSetColumnChanged()
    modelReplaced            : typing.ClassVar[Signal] = ... # modelReplaced()
    rowCountChanged          : typing.ClassVar[Signal] = ... # rowCountChanged()
    seriesReplaced           : typing.ClassVar[Signal] = ... # seriesReplaced()


class QVBoxPlotModelMapper(PySide6.QtCharts.QBoxPlotModelMapper):

    firstBoxSetColumnChanged : typing.ClassVar[Signal] = ... # firstBoxSetColumnChanged()
    firstRowChanged          : typing.ClassVar[Signal] = ... # firstRowChanged()
    lastBoxSetColumnChanged  : typing.ClassVar[Signal] = ... # lastBoxSetColumnChanged()
    modelReplaced            : typing.ClassVar[Signal] = ... # modelReplaced()
    rowCountChanged          : typing.ClassVar[Signal] = ... # rowCountChanged()
    seriesReplaced           : typing.ClassVar[Signal] = ... # seriesReplaced()


class QVCandlestickModelMapper(PySide6.QtCharts.QCandlestickModelMapper):

    closeRowChanged          : typing.ClassVar[Signal] = ... # closeRowChanged()
    firstSetColumnChanged    : typing.ClassVar[Signal] = ... # firstSetColumnChanged()
    highRowChanged           : typing.ClassVar[Signal] = ... # highRowChanged()
    lastSetColumnChanged     : typing.ClassVar[Signal] = ... # lastSetColumnChanged()
    lowRowChanged            : typing.ClassVar[Signal] = ... # lowRowChanged()
    openRowChanged           : typing.ClassVar[Signal] = ... # openRowChanged()
    timestampRowChanged      : typing.ClassVar[Signal] = ... # timestampRowChanged()


class QVPieModelMapper(PySide6.QtCharts.QPieModelMapper):

    firstRowChanged          : typing.ClassVar[Signal] = ... # firstRowChanged()
    labelsColumnChanged      : typing.ClassVar[Signal] = ... # labelsColumnChanged()
    modelReplaced            : typing.ClassVar[Signal] = ... # modelReplaced()
    rowCountChanged          : typing.ClassVar[Signal] = ... # rowCountChanged()
    seriesReplaced           : typing.ClassVar[Signal] = ... # seriesReplaced()
    valuesColumnChanged      : typing.ClassVar[Signal] = ... # valuesColumnChanged()


class QVXYModelMapper(PySide6.QtCharts.QXYModelMapper):

    firstRowChanged          : typing.ClassVar[Signal] = ... # firstRowChanged()
    modelReplaced            : typing.ClassVar[Signal] = ... # modelReplaced()
    rowCountChanged          : typing.ClassVar[Signal] = ... # rowCountChanged()
    seriesReplaced           : typing.ClassVar[Signal] = ... # seriesReplaced()
    xColumnChanged           : typing.ClassVar[Signal] = ... # xColumnChanged()
    yColumnChanged           : typing.ClassVar[Signal] = ... # yColumnChanged()


class QValueAxis(PySide6.QtCharts.QAbstractAxis):

    labelFormatChanged       : typing.ClassVar[Signal] = ... # labelFormatChanged(QString)
    maxChanged               : typing.ClassVar[Signal] = ... # maxChanged(double)
    minChanged               : typing.ClassVar[Signal] = ... # minChanged(double)
    minorTickCountChanged    : typing.ClassVar[Signal] = ... # minorTickCountChanged(int)
    rangeChanged             : typing.ClassVar[Signal] = ... # rangeChanged(double,double)
    tickAnchorChanged        : typing.ClassVar[Signal] = ... # tickAnchorChanged(double)
    tickCountChanged         : typing.ClassVar[Signal] = ... # tickCountChanged(int)
    tickIntervalChanged      : typing.ClassVar[Signal] = ... # tickIntervalChanged(double)
    tickTypeChanged          : typing.ClassVar[Signal] = ... # tickTypeChanged(QValueAxis::TickType)

    class TickType(enum.Enum):

        TicksDynamic              = 0x0
        TicksFixed                = 0x1


class QXYLegendMarker(PySide6.QtCharts.QLegendMarker): ...


class QXYModelMapper(PySide6.QtCore.QObject): ...


class QXYSeries(PySide6.QtCharts.QAbstractSeries):

    bestFitLineColorChanged  : typing.ClassVar[Signal] = ... # bestFitLineColorChanged(QColor)
    bestFitLinePenChanged    : typing.ClassVar[Signal] = ... # bestFitLinePenChanged(QPen)
    bestFitLineVisibilityChanged: typing.ClassVar[Signal] = ... # bestFitLineVisibilityChanged(bool)
    clicked                  : typing.ClassVar[Signal] = ... # clicked(QPointF)
    colorChanged             : typing.ClassVar[Signal] = ... # colorChanged(QColor)
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked(QPointF)
    hovered                  : typing.ClassVar[Signal] = ... # hovered(QPointF,bool)
    lightMarkerChanged       : typing.ClassVar[Signal] = ... # lightMarkerChanged(QImage)
    markerSizeChanged        : typing.ClassVar[Signal] = ... # markerSizeChanged(double)
    penChanged               : typing.ClassVar[Signal] = ... # penChanged(QPen)
    pointAdded               : typing.ClassVar[Signal] = ... # pointAdded(int)
    pointLabelsClippingChanged: typing.ClassVar[Signal] = ... # pointLabelsClippingChanged(bool)
    pointLabelsColorChanged  : typing.ClassVar[Signal] = ... # pointLabelsColorChanged(QColor)
    pointLabelsFontChanged   : typing.ClassVar[Signal] = ... # pointLabelsFontChanged(QFont)
    pointLabelsFormatChanged : typing.ClassVar[Signal] = ... # pointLabelsFormatChanged(QString)
    pointLabelsVisibilityChanged: typing.ClassVar[Signal] = ... # pointLabelsVisibilityChanged(bool)
    pointRemoved             : typing.ClassVar[Signal] = ... # pointRemoved(int)
    pointReplaced            : typing.ClassVar[Signal] = ... # pointReplaced(int)
    pointsConfigurationChanged: typing.ClassVar[Signal] = ... # pointsConfigurationChanged(QXYSeries::PointsConfigurationHash)
    pointsRemoved            : typing.ClassVar[Signal] = ... # pointsRemoved(int,int)
    pointsReplaced           : typing.ClassVar[Signal] = ... # pointsReplaced()
    pressed                  : typing.ClassVar[Signal] = ... # pressed(QPointF)
    released                 : typing.ClassVar[Signal] = ... # released(QPointF)
    selectedColorChanged     : typing.ClassVar[Signal] = ... # selectedColorChanged(QColor)
    selectedLightMarkerChanged: typing.ClassVar[Signal] = ... # selectedLightMarkerChanged(QImage)
    selectedPointsChanged    : typing.ClassVar[Signal] = ... # selectedPointsChanged()

    class PointConfiguration(enum.Enum):

        Color                     = 0x0
        Size                      = 0x1
        Visibility                = 0x2
        LabelVisibility           = 0x3
        LabelFormat               = 0x4


# eof
